#version 120
#extension GL_ARB_shader_texture_lod : enable


/*






!! DO NOT REMOVE !! !! DO NOT REMOVE !!

This code is from Chocapic13' shaders
Read the terms of modification and sharing before changing something below please !
!! DO NOT REMOVE !! !! DO NOT REMOVE !!


Sharing and modification rules

Sharing a modified version of my shaders:
-You are not allowed to claim any of the code included in "Chocapic13' shaders" as your own
-You can share a modified version of my shaders if you respect the following title scheme : " -Name of the shaderpack- (Chocapic13' Shaders edit) "
-You cannot use any monetizing links
-The rules of modification and sharing have to be same as the one here (copy paste all these rules in your post), you cannot make your own rules
-I have to be clearly credited
-You cannot use any version older than "Chocapic13' Shaders V4" as a base, however you can modify older versions for personal use
-Common sense : if you want a feature from another shaderpack or want to use a piece of code found on the web, make sure the code is open source. In doubt ask the creator.
-Common sense #2 : share your modification only if you think it adds something really useful to the shaderpack(not only 2-3 constants changed)


Special level of permission; with written permission from Chocapic13, if you think your shaderpack is an huge modification from the original (code wise, the look/performance is not taken in account):
-Allows to use monetizing links
-Allows to create your own sharing rules
-Shaderpack name can be chosen
-Listed on Chocapic13' shaders official thread
-Chocapic13 still have to be clearly credited


Using this shaderpack in a video or a picture:
-You are allowed to use this shaderpack for screenshots and videos if you give the shaderpack name in the description/message
-You are allowed to use this shaderpack in monetized videos if you respect the rule above.


Minecraft website:
-The download link must redirect to the link given in the shaderpack's official thread
-You are not allowed to add any monetizing link to the shaderpack download

If you are not sure about what you are allowed to do or not, PM Chocapic13 on http://www.minecraftforum.net/
Not respecting these rules can and will result in a request of thread/download shutdown to the host/administrator, with or without warning. Intellectual property stealing is punished by law.











*/
#define MAX_COLOR_RANGE 48.0

const int 		noiseTextureResolution  = 1024;
//////////////////////////////ADJUSTABLE VARIABLES
//////////////////////////////ADJUSTABLE VARIABLES
//////////////////////////////ADJUSTABLE VARIABLES

	#define GODRAYS			//in this step previous godrays result is blurred
		const float exposure = 2.;			//godrays intensity
		const float density = 1.0;
		const int NUM_SAMPLES = 13;			//increase this for better quality at the cost of performance
		const float grnoise = 0.0;		//amount of noise

	//#define SPECULAR	///Best used with normal mapping or POM
	#define WATER_REFLECTIONS
	//#define RAIN_REFLECTIONS	//Best used with normal mapping or POM

	//#define CAUSTICS_WIP
//////////////////////////////END OF ADJUSTABLE VARIABLES
//////////////////////////////END OF ADJUSTABLE VARIABLES
//////////////////////////////END OF ADJUSTABLE VARIABLES

const bool compositeMipmapEnabled = true;

//don't touch these lines if you don't know what you do!
const int maxf = 8;				//number of refinements
const float stp = 1.0;			//size of one step for raytracing algorithm
const float ref = 0.05;			//refinement multiplier
const float inc = 2.2;			//increasement factor at each step
//ground constants (lower quality)
const int Gmaxf = 3;				//number of refinements
const float Gstp = 1.2;			//size of one step for raytracing algorithm
const float Gref = 0.11;			//refinement multiplier
const float Ginc = 3.0;			//increasement factor at each step
/*--------------------------------*/
varying vec4 texcoord;

varying vec3 lightVector;
varying vec3 sunVec;
varying vec3 moonVec;
varying vec3 upVec;

varying vec3 sunlight;
varying vec3 moonlight;
varying vec3 ambient_color;
varying vec3 fcolor;
varying vec3 sunlightColor;
varying vec2 lmcoord;

varying float eyeAdapt;

varying vec4 temperature;

varying float SdotU;
varying float MdotU;
varying float sunVisibility;
varying float moonVisibility;

uniform sampler2D composite;
uniform sampler2D gaux1;
uniform sampler2D gaux3;
uniform sampler2D gaux4;
uniform sampler2D depthtex0;
uniform sampler2D depthtex1;
uniform sampler2D gnormal;
uniform sampler2D gdepth;
uniform sampler2D gdepthtex;
uniform sampler2D noisetex;

uniform vec3 sunPosition;
uniform vec3 moonPosition;
uniform vec3 upPosition;
uniform vec3 cameraPosition;
uniform vec3 skyColor;

uniform mat4 gbufferProjection;
uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferModelView;

uniform int isEyeInWater;
uniform int worldTime;
uniform float far;
uniform float near;
uniform float aspectRatio;
uniform float viewWidth;
uniform float viewHeight;
uniform float rainStrength;
uniform float wetness;
uniform float frameTimeCounter;
uniform int fogMode;
uniform ivec2 eyeBrightnessSmooth;
/*--------------------------------*/
vec2 wind[4] = vec2[4](vec2(abs(frameTimeCounter/1000.-0.5),abs(frameTimeCounter/1000.-0.5))+vec2(0.5),
					vec2(-abs(frameTimeCounter/1000.-0.5),abs(frameTimeCounter/1000.-0.5)),
					vec2(-abs(frameTimeCounter/1000.-0.5),-abs(frameTimeCounter/1000.-0.5)),
					vec2(abs(frameTimeCounter/1000.-0.5),-abs(frameTimeCounter/1000.-0.5)));
					float timefract = worldTime;

					//Raining
					float rainx = clamp(rainStrength, 0.0f, 1.0f)/1.0f;
					float wetx  = clamp(wetness, 0.0f, 1.0f);

					//Calculate Time of Day
					float TimeSunrise  = ((clamp(timefract, 23000.0, 24000.0) - 23000.0) / 1000.0) + (1.0 - (clamp(timefract, 0.0, 4000.0)/4000.0));
					float TimeNoon     = ((clamp(timefract, 0.0, 4000.0)) / 4000.0) - ((clamp(timefract, 8000.0, 12000.0) - 8000.0) / 4000.0);
					float TimeSunset   = ((clamp(timefract, 8000.0, 12000.0) - 8000.0) / 4000.0) - ((clamp(timefract, 12000.0, 12750.0) - 12000.0) / 750.0);
					float TimeMidnight = ((clamp(timefract, 12000.0, 12750.0) - 12000.0) / 750.0) - ((clamp(timefract, 23000.0, 24000.0) - 23000.0) / 1000.0);

float pw = 1.0/ viewWidth;
float ph = 1.0/ viewHeight;
/*--------------------------------*/
float matflag = texture2D(gaux1,texcoord.xy).g;

float frametime = frameTimeCounter;

/*--------------------------------*/
vec3 fragpos = vec3(texcoord.st, texture2D(depthtex0, texcoord.st).r);
vec3 normal = texture2D(gnormal, texcoord.st).rgb * 2.0 - 1.0;
float underCover = pow(lmcoord.t, 15);
float time = float(worldTime);
float night = clamp((time-12000.0)/300.0,0.0,1.0)-clamp((time-22800.0)/200.0,0.0,1.0);
/*--------------------------------*/
float sky_lightmap = texture2D(gaux1,texcoord.xy).r;
float iswet = wetness*pow(sky_lightmap,5.0)*sqrt(0.5+max(dot(normal,upVec),0.0));

vec4 specular = pow(texture2D(gaux3,texcoord.xy).rgba,vec4(2.2));
float specRoughness = (specular.r)/10;
/*--------------------------------*/
vec4 color = texture2DLod(composite,texcoord.xy,0);
float transition_fading = 1.0-(clamp((time-12000.0)/300.0,0.0,1.0)-clamp((time-13500.0)/300.0,0.0,1.0) + clamp((time-22500.0)/300.0,0.0,1.0)-clamp((time-23400.0)/300.0,0.0,1.0));	//fading between sun/moon shadows

const float e =2.71828;
const float pi = 3.14159265359;

vec3 nvec3(vec4 pos) {
    return pos.xyz/pos.w;
}
/*--------------------------------*/
vec4 nvec4(vec3 pos) {
    return vec4(pos.xyz, 1.0);
}
/*--------------------------------*/
float cdist(vec2 coord) {
	return max(abs(coord.s-0.5),abs(coord.t-0.5))*2.0;
}

vec3 luma(vec3 color) {
	float dot = dot(color,vec3(0.299, 0.587, 0.114));
	vec3 c = vec3(dot);
	return c;
}



vec3 getSkyColor(vec3 fposition) {
	/*--------------------------------*/
	vec3 sky_color = vec3(0.15098039215, 0.41176470588, 0.98039215686);
	vec3 nsunlight = normalize(pow(sunlight,vec3(2.2))*vec3(0.05, 0.3, 1.));
	vec3 sVector = normalize(fposition);
	/*--------------------------------*/
	sky_color = normalize(mix(sky_color,vec3(0.25,0.3,0.4)*sqrt(dot(ambient_color, ambient_color)),rainStrength)); //normalize colors in order to don't change luminance
	/*--------------------------------*/
	float Lz = 1.0;
	float cosT = dot(sVector,upVec);
	float absCosT = max(cosT,0.0);
	float cosS = dot(sunVec,upVec);
	float S = acos(cosS);
	float cosY = dot(sunVec,sVector);
	float Y = acos(cosY);
	/*--------------------------------*/
	float a = -1.;
	float b = -0.24;
	float c = 6.0;
	float d = -0.8;
	float e = 0.45;
	/*--------------------------------*/

	//sun sky color
	float L =  (1+a*exp(b/(absCosT+0.01)))*(1+c*exp(d*Y)+e*cosY*cosY);
	L = L; //modulate intensity when raining
	/*--------------------------------*/
	vec3 skyColorSun = mix(sky_color, nsunlight,1-exp(-0.005*pow(L,4.)*(1-rainStrength)))*L*0.5*vec3(0.8,0.9,1.); //affect color based on luminance (0% physically accurate)
	skyColorSun *= sunVisibility;
	/*--------------------------------*/

	//moon sky color
	float McosS = MdotU;
	float MS = acos(McosS);
	float McosY = dot(moonVec,sVector);
	float MY = acos(McosY);
	/*--------------------------------*/
	float L2 =  (1+a*exp(b/(absCosT+0.01)))*(1+c*exp(d*MY)+e*McosY*McosY)+0.2;
	L2 = pow(L2,1.0-rainStrength*0.8)*(1.0-rainStrength*0.83); //modulate intensity when raining
	/*--------------------------------*/
	vec3 skyColormoon = mix(moonlight,normalize(vec3(0.25,0.3,0.4))*length(moonlight),rainStrength*0.8)*L2*0.8 ; //affect color based on luminance (0% physically accurate)
	skyColormoon *= moonVisibility/10;
	sky_color = skyColormoon*2.0+skyColorSun;
	/*--------------------------------*/
	return sky_color;
}

vec3 fogColor(){
	vec3 fogColor;
	return fogColor = getSkyColor(fragpos);
}


vec3 drawSun(vec3 fposition,vec3 color,int land) {
	vec3 sVector = normalize(fposition);

	float angle = (1-max(dot(sVector,sunVec),0.0))*400.0;
	float sun = exp((-angle)*(angle));
	sun *= land*(1-rainStrength*0.9925)*sunVisibility;
	vec3 sunlight = mix(sunlight,vec3(0.25,0.3,0.4)*length(ambient_color),rainStrength*0.8);
	return mix(color,sunlight*4.,sun);

}

vec3 skyGradient (vec3 fposition, vec3 color, vec3 fogclr) {
	const float density = 500.0;
	const float start = 0.0;
	float rainFog = 1.0+4.0*rainStrength;

	float fog = min(exp(-sqrt(dot(fposition, fposition))/density/(sunVisibility*0.7+0.3)*rainFog)+start*sunVisibility*(1-rainStrength),1.0);

	vec3 fc = fogclr;
	return mix(fc,color,fog);
}

float getAirDensity (float h) {
	return min((pow((max((h),58.0)-58.0)/30.,2.0)*20.0+10.0),35.0);
}


vec3 calcFog(vec3 fposition, vec3 color, vec3 fogclr) {
	vec3 worldpos = (gbufferModelViewInverse*vec4(fposition,1.0)).rgb+cameraPosition;
	float horizon = (worldpos.y - (texcoord.y-cameraPosition.y));
	float calcHeight = (max(pow(max(4 - horizon/120.0, 0.0), 1.0)-0.0, 0.0));
	vec3 fogC = fogclr*0.9*(0.7+0.3);

	vec3 fragposFog = vec3(texcoord.st, texture2D(depthtex0, texcoord.st).r);
	fragposFog = nvec3(gbufferProjectionInverse * nvec4(fragposFog * 2.0 - 1.0));
	float fog = exp(-pow(sqrt(dot(fragposFog,fragposFog))/far*0.6 *(1.0 - rainStrength * 1.8),2.0));
	float fogfactor =  clamp(fog,0.0,1.0);

	return mix(color,getSkyColor(fragposFog)*calcHeight,clamp(1-fogfactor/1.1, 0.0, 1.0));
}

float dynamicExposure() {
		return clamp((-eyeBrightnessSmooth.y+230)/100.0,0.0,1.0);
}



vec3 getFog(in vec3 color, in bool land, in vec2 pos, in vec3 ambient_color){
	vec3 fogclr;
	vec3 fogclr2;
	vec3 fogclr3;

	vec3 fragposFog = vec3(pos.st, texture2D(depthtex0, pos.st).r);
	fragposFog = nvec3(gbufferProjectionInverse * nvec4(fragposFog * 2.0 - 1.0));

	vec4 worldposition = vec4(0.0);
		 worldposition = gbufferModelViewInverse * vec4(fragposFog,1.0);
	float horizon = (worldposition.y - (pos.y-cameraPosition.y));
ambient_color = mix(ambient_color, ambient_color*7.5, TimeMidnight);
	float calcHeight = (max(pow(max(1.5 - horizon/100.0, 0.0), 1.0)-0.0, 0.0)); //day time

	float volumetric_cone = pow(max(dot(normalize(fragposFog),lightVector),0.0),2.5)*transition_fading;
	float volumetric_cone2 = pow(max(dot(normalize(fragposFog),lightVector),0.0),10.0*400.0);
	float volumetric_cone3 = pow(max(dot(normalize(fragposFog),lightVector),0.0),10.0*1000.0)*transition_fading;
	float norain = 1.0-rainStrength;

	if (isEyeInWater > .9) {
	} else {

		float fog = exp(-pow(sqrt(dot(fragposFog,fragposFog))/far*0.6*(1-(TimeSunrise+TimeSunset)*1) ,2.0));
		float fog2 = exp(-pow(sqrt(dot(fragposFog,fragposFog))/70 ,2.0));
		float fog3 = exp(-pow(sqrt(dot(fragposFog,fragposFog))/140 ,2.0));
		float fog4 = exp(-pow(sqrt(dot(fragposFog,fragposFog))/40 ,2.0));
		float fogfactor =  clamp(fog,0.0,1.0);
		float fogfactor2 =  clamp(fog2,0.0,1.0);
		float fogfactor3 =  clamp(fog3,0.0,1.0);
		float fogfactor4 =  clamp(fog4,0.0,1.0)*rainStrength;

		vec3 rainfogclr = vec3(0.08,0.1,0.1)*rainStrength*mix(1-TimeMidnight,1.0,(1-transition_fading) * pow(TimeSunrise + TimeSunset, 0.5));
		fogclr2 = mix(color.rgb,rainfogclr*8.0,1.0)*rainx;
		fogclr2 += mix(color.rgb,ambient_color*0.5,1.0)*rainStrength*(TimeMidnight + (1-transition_fading));
		fogclr2 -= fogclr2*0.4*rainStrength;
		fogclr = mix(color.rgb,ambient_color,0.6 + clamp((20000*TimeMidnight), 0.0, 0.25))*(1.0-rainStrength)*(1.0-TimeMidnight*0.895);
		fogclr = clamp(mix(fogclr, ambient_color, (1-TimeMidnight)*(1+TimeSunrise*.25)*(1+TimeNoon*.5)),0.0,1.0);
		fogclr.g -= fogclr.g*0.15;
		fogclr.rb -= fogclr.rb*0.1*(TimeSunrise+TimeSunset);

		//glow

		fogclr += pow(sunlight,vec3(2.2)) * volumetric_cone*transition_fading*(1.0-TimeMidnight)*(1.0-TimeNoon)*(1.0-rainStrength*0.4)*2.5;
		fogclr += fogclr * 0.05 * volumetric_cone*2*transition_fading*TimeMidnight*(1.0-rainStrength)*1.0;

		fogclr = mix(fogclr,sunlight,volumetric_cone*0.5*(1.0-TimeMidnight)*(1.0-TimeSunrise)*(1.0-TimeSunset)*(1.0-rainStrength)*1.0);

		//main fog
		if (!land) {
		} else {
			color.rgb = mix(color.rgb,fogclr,(1-fogfactor)*(1-clamp(calcHeight,0.0,1.0))*.5*(1- dynamicExposure()));
			color.rgb = mix(color.rgb,fogclr2/2,(1-fogfactor2)*rainStrength*(1-TimeMidnight));
		}

 		//add rain fog color to sky
		if (land) {
			} else {
				color.rgb += vec3(rainfogclr*rainStrength)*(1.0*rainStrength)*(1.0-TimeMidnight);
			}

		//adding rain fog to day and night
		color.rgb = mix(color.rgb,fogclr2,(1-fogfactor2)*rainStrength);

		//altitude fog
		if (!land) {
			} else {
				color.rgb = mix(color.rgb,fogclr.rgb,clamp((1-fogfactor)*(1-rainStrength)*(1-TimeMidnight)*(clamp((calcHeight), 0.0, 1.0)),0.0,1.0));

				calcHeight = (max(pow(max(0.6 - horizon/300.0, 0.0), 8.0)-0.0, 0.0));	//night time
				color.rgb  = mix(color.rgb,clamp(fogclr * 1.5, 0.0, 1.0),clamp(3.0*(clamp((calcHeight) * 10, 0.0, 1.0))*(TimeMidnight)*(1- rainStrength)*(1-TimeSunrise)*(transition_fading)*(1-fogfactor3),0.0,1.0));
			}

	}
	return color;
}

/*
vec3 calcFog(vec3 fposition, vec3 color, vec3 fogclr) {
float d = sqrt(dot(fposition, fposition));

float density = (5500);


vec3 worldpos = (gbufferModelViewInverse*vec4(fposition,1.0)).rgb+cameraPosition;
float height = mix(getAirDensity (worldpos.y),0.1,rainStrength);

float fog =   clamp(18.0*exp(-getAirDensity (-cameraPosition.y)/density) * (1.0-exp( -d*height/density ))/height-0.28+rainStrength*0.28,0.0,1.);
vec3 fogC = fogclr*0.9*(0.7+0.3);

return mix(color,getSkyColor(fragpos),fog);
}
*/

vec4 raytrace(vec3 fragpos, vec3 normal,vec3 fogclr, float roughness) {
	vec4 color;
	vec3 start = fragpos;
	vec3 rvector = normalize(reflect(normalize(fragpos), normalize(normal)));

	vec3 vector = Gstp * rvector;

	vec3 oldpos = fragpos;
	fragpos += vector;
vec3 tvector = vector;
	int sr = 0;

	for(int i=0;i<30;i++){
			vec3 pos = nvec3(gbufferProjection * nvec4(fragpos)) * 0.5 + 0.5;
	if(pos.x < 0 || pos.x > 1 || pos.y < 0 || pos.y > 1 || pos.z < 0 || pos.z > 1.0) break;
			vec3 spos = vec3(pos.st, texture2D(depthtex1, pos.st).r);
			spos = nvec3(gbufferProjectionInverse * nvec4(spos * 2.0 - 1.0));
			float err = distance(fragpos.xyz,spos.xyz);
			 if(err < pow(sqrt(dot(vector, vector))*pow(sqrt(dot(tvector, tvector)),0.11),1.1)*1.1){

							sr++;
							if(sr >= maxf){
									float border = clamp(1.0 - pow(cdist(pos.st), 20.0), 0.0, 1.0);
									color = texture2DLod(composite, pos.st, roughness);
				float land = texture2D(gaux1, pos.st).g;
				land = float(land < 0.03);
					if (land > 0.9) color.rgb = fogclr;
			    if (land < 0.9) color.rgb = pow(color.rgb,vec3(2.2))*MAX_COLOR_RANGE;
			    if (land < 0.9) color.rgb = getFog(color.rgb,bool(1-land), pos.st, getSkyColor(fragpos));
				color.a = 1.0;
									color.a *= border;
									break;
							}
			tvector -=vector;
							vector *=Gref;


}
			vector *= Ginc;
			oldpos = fragpos;
			tvector += vector;
	fragpos = start + tvector;
	}
	return color;
}

vec3 underwaterFog (float depth,vec3 color) {
	const float density = 100000.0;
	float fog = exp(-depth/density);
	/*--------------------------------*/
	vec3 Ucolor= normalize(pow(vec3(0.1,0.4,0.6),vec3(2.2)))*(sqrt(3.0));
	/*--------------------------------*/
	vec3 c = mix(color*Ucolor,color,fog);
	vec3 fc = Ucolor*sqrt(dot(ambient_color, ambient_color))*0.02;
	return mix(fc,c,fog);
}

float subSurfaceScattering(vec3 vec,vec3 pos, float N) {

	return pow(max(dot(vec,normalize(pos)),0.0),N)*(N+1)/6.28;

}
float subSurfaceScattering2(vec3 vec,vec3 pos, float N) {

	return pow(max(dot(vec,normalize(pos))*0.5+0.5,0.0),N)*(N+1)/6.28;

}



vec3 drawCloud(vec3 fposition,vec3 color) {
   float Size = 1.0;
   vec3 sVector = normalize(fposition);
   float cosT = max(dot(normalize(sVector),upVec),0.0);
   vec3 tpos = vec3(gbufferModelViewInverse * vec4(sVector,0.0));
   vec3 wvec = normalize(tpos);
   vec3 wVector = normalize(tpos);

   vec3 cloudCol = pow(sunlight * 2.4,vec3(3.4))*(TimeSunrise+TimeSunset);
    cloudCol += (sunlight * 2.0)*(TimeNoon);
    cloudCol += (moonlight * 1000.0)*(TimeMidnight/500);
    cloudCol += pow(sunlight * 1.5,vec3(3.0)) * (1-transition_fading);

   float totalcloud = 0.0;

   float height = (700.0)/(wVector.y);
   vec2 wind = vec2(abs(frameTimeCounter/20000.-0.5),abs(frameTimeCounter/20000.-0.5))+vec2(0.5);

   vec3 intersection;
   float density;
   float d1;

   int Steps = 5;
   float weight;

   for (int i = 0; i < Steps; i++) {
    intersection = wVector * (height - i * 150 * Size / Steps);    //curved cloud plane

    vec2 coord1 = (intersection.xz+cameraPosition.xz*2.5)/200000;
    coord1 += (wind);
    vec2 coord = (coord1/Size);

    float noise = texture2D(noisetex,coord - wind * 0.25).x;
    noise += texture2D(noisetex,coord*3.5).x/3.5;
    noise += texture2D(noisetex,coord*6.125).x/6.125;
    noise += texture2D(noisetex,coord*12.25).x/12.25;
    noise /= clamp(texture2D(noisetex,coord / 4.1).x * 1.25,0.0,1.0);
    noise *= (pow(noise, pow(2.0 * pow(1.0,0.5),0.5)));
    noise /= 0.13;

    float cl = max(noise-0.7,0.0);
    cl = max(cl,0.)*0.05 * (1.0 - rainx * 0.9);
    density = max(1-cl*2.5,0.)*max(1-cl*2.5,0.) / 11.0 / 3.0;
    density *= 2.0;

    totalcloud += density;
    if (totalcloud > (1.0 - 1.0 / Steps + 0.1)) break;
    weight ++;

   }

   cloudCol = mix(cloudCol*pow(1-density, 2.0),vec3(cloudCol*0.125),pow(density, 2.0)) * 2.0;

   cloudCol += pow(sunlight * mix(3.0,2.4,TimeSunset + TimeSunrise),vec3(mix(3.4 - (1.0 * (1.0 - transition_fading)),1.0,TimeNoon)))* (50*(pow(1-density, 100.0 * (1-(1-transition_fading * 0.5))))) * mix(1.0,0.1,1.0 - transition_fading) * 1.5 * (1-(TimeMidnight * transition_fading)) * (1-rainx);
   cloudCol += pow(sunlight * mix(3.0,2.4,TimeSunset + TimeSunrise),vec3(mix(3.4 - (1.0 * (1.0 - transition_fading)),1.0,TimeNoon))) * 25 * (1- TimeMidnight);
   cloudCol += moonlight * (50*(pow(1-density, 14.0))) * 70 * transition_fading * (1-rainx);

   cloudCol *= (1- (0.5 * TimeMidnight * transition_fading));
   cloudCol *= (1+ TimeNoon);
   cloudCol = mix(cloudCol,vec3(0.0),pow(1-density, 100.0));

   totalcloud = min(totalcloud / weight,1.0);
   return mix(color.rgb,cloudCol * 1.0 * 0.175 * 0.5 * (1.0 - rainx * 0.8),totalcloud * pow(cosT,2.0));
 }

 void calcGodRays(vec2 lightPos){
	 float truepos = sunPosition.z/abs(sunPosition.z);		//1 -> sun / -1 -> moon
	 vec3 rainc = mix(vec3(1.),fogColor()*1.5,rainStrength);
	 vec3 lightColor = mix(sunlight*sunVisibility*rainc,4*moonlight*moonVisibility*rainc,(truepos+1.0)/2.);
	 float gr = 0.0;

	 const int nSteps = NUM_SAMPLES;
	 const float blurScale = 0.002/nSteps*9.0;
	 const int center = (nSteps-1)/2;
	 vec3 blur = vec3(0.0);
	 float tw = 0.0;
	 const float sigma = 0.5;

	 vec2 deltaTextCoord = normalize(texcoord.st - lightPos.xy)*blurScale;
	 vec2 textCoord = texcoord.st - deltaTextCoord*center;
	 float distx = texcoord.x*aspectRatio-lightPos.x*aspectRatio;
	 float disty = texcoord.y-lightPos.y;
	 float illuminationDecay = pow(max(1.0-sqrt(distx*distx+disty*disty),0.0),4.0);

		 for(int i=0; i < nSteps ; i++) {
			 textCoord += deltaTextCoord;

			 float dist = (i-float(center))/center;
			 float weight = exp(-(dist*dist)/(2.0*sigma));

			 float sample = texture2D(gdepth, textCoord).r*weight;
			 tw += weight;
			 gr += sample;
	 }

	 vec3 grC = mix(lightColor,fogColor(),rainStrength)*exposure*(gr/tw)*illuminationDecay * (1-isEyeInWater);
	 if(rainStrength < 0.9) color.xyz = (1-(1-color.xyz/48.0)*(1-grC.xyz/48.0))*48.0;

 }


 float getWaterDepth(in vec4 worldposition){

 	vec2 coord1;
 	vec2 coord2;
 	vec2 coord3;

 	float maskCoord1;
 	float maskCoord2;
 	float maskCoord3;

 	vec3 refraction;

 	#ifdef WATER_REFRACT
 		waterRefractCoord(worldposition, maskCoord1, maskCoord2, maskCoord3, coord1, coord2, coord3, refraction);
 		vec2 getCustomTc = texcoord.st + refraction.st;
 		float refractMask = refractmask(getCustomTc);

 		getCustomTc -= refraction.st * (1-refractMask);
 	#else
 		vec2 getCustomTc = texcoord.st;
 	#endif

 	vec3 uPos = vec3(.0);

 	float uDepth = texture2D(depthtex1,getCustomTc).x;
 	uPos = nvec3(gbufferProjectionInverse * vec4(vec3(getCustomTc.xy,uDepth) * 2.0 - 1.0, 1.0));

 	vec3 uVec = fragpos-uPos;

 	float UNdotUP = abs(dot(normalize(uVec),normal));
 	float depth = sqrt(dot(uVec,uVec))*UNdotUP;

 	//depth *= refractMask;

 	return depth;
 }

 float waterH(vec2 posxz) {

 vec2 movement = vec2(abs(frameTimeCounter/1000.-0.5),abs(frameTimeCounter/1000.-0.5));
 vec2 movement2 = vec2(-abs(frameTimeCounter/1000.-0.5),abs(frameTimeCounter/1000.-0.5));
 vec2 movement3 = vec2(-abs(frameTimeCounter/1000.-0.5),-abs(frameTimeCounter/1000.-0.5));
 vec2 movement4 = vec2(abs(frameTimeCounter/1000.-0.5),-abs(frameTimeCounter/1000.-0.5));

 vec2 coord = (posxz/600)+(movement/5);
 vec2 coord1 = (posxz/599.9)+(movement2/5);
 vec2 coord2 = (posxz/599.8)+(movement3/5);
 vec2 coord3 = (posxz/599.7)+(movement4);
 vec2 coord4 = (posxz/1600)+(movement/1.5);
 vec2 coord5 = (posxz/1599)+(movement2/1.5);
 vec2 coord6 = (posxz/1598)+(movement3/1.5);
 vec2 coord7 = (posxz/1597)+(movement4/1.5);

 float noise = texture2D(noisetex, vec2(coord.x, -coord.y*5)).x/2;
 noise += texture2D(noisetex, vec2(-coord2.x, coord2.y)).x/2;
 noise += texture2D(noisetex, vec2(coord3.x, -coord3.y*3)).z/2;
 noise += texture2D(noisetex, vec2(-coord6.x*2, coord4.y)).x/2;
 noise += texture2D(noisetex, vec2(coord7.x, -coord5.y)).x/2;

 return noise;
 }

 vec3 getWaveHeight(vec2 posxz){

 	vec2 coord = (posxz);

 		float deltaPos = 0.3;

 		//float fc = (find_closest(texcoord.st,deltaPos));
 		float h0 = waterH(coord);
 		float h1 = waterH(coord + vec2(deltaPos,0.0));
 		float h2 = waterH(coord + vec2(-deltaPos,0.0));
 		float h3 = waterH(coord + vec2(0.0,deltaPos));
 		float h4 = waterH(coord + vec2(0.0,-deltaPos));

 		float xDelta = ((h1-h0)+(h0-h2))/deltaPos;
 		float yDelta = ((h3-h0)+(h0-h4))/deltaPos;

 		vec3 wave = normalize(vec3(xDelta,yDelta,1.0-pow(abs(xDelta+yDelta),2.0)));

 		return wave;
 }


 float convertVec3ToFloat(in vec3 invec){

 	float mixing;
 		mixing += invec.x;
 		mixing += invec.y;
 		mixing += invec.z;
 		mixing /= 3.0;

 	return mixing;
 }



 vec3 waterCaustic(vec3 color, float visibility, in bool land, in vec4 worldposition) {

	 vec2 coord1;
	 vec2 coord2;
	 vec2 coord3;

	 float maskCoord1;
	 float maskCoord2;
	 float maskCoord3;

	 vec3 refraction;

		 vec2 getCustomTc = texcoord.st;

	 vec3 underwaterpos = vec3(getCustomTc, texture2D(depthtex1, getCustomTc).r);
			underwaterpos = nvec3(gbufferProjectionInverse * nvec4(underwaterpos * 2.0 - 1.0));

	 vec4 worldpositionuw = gbufferModelViewInverse * vec4(underwaterpos,1.0);
	 vec3 wpos = (worldpositionuw.xyz + cameraPosition.xyz);

	 vec2 coord = vec2(wpos.xz + wpos.y);

	 vec3 caustics = getWaveHeight(coord);

	 float getcoustic = convertVec3ToFloat(caustics)/2.0;

	 float wca = (1 * 1.5);
	 float caustic = 1-(pow(0.05,clamp(getcoustic,-3.0,1.0)*1.1));
	 vec3 wc = clamp(mix(color * visibility * wca,vec3(0),1-caustic * 2.0),0.0,1.0);

 if (land)
	 return wc;
	 //return -0.1+caustics;
 }

void main() {
	color.rgb = pow(color.rgb,vec3(2.2))*MAX_COLOR_RANGE;
	/*--------------------------------*/
	int land = int(matflag < 0.03);
	bool land2 = bool(1-land);
	int iswater = int(matflag > 0.04 && matflag < 0.07);
	int hand  = int(matflag > 0.75 && matflag < 0.85);
	vec4 worldposition = vec4(0.0);
		 worldposition = gbufferModelViewInverse * vec4(fragpos,1.0);

	float depth = getWaterDepth(worldposition);

	fragpos = nvec3(gbufferProjectionInverse * nvec4(fragpos * 2.0 - 1.0));
	vec3 tfpos = fragpos.xyz;
	float pixeldepth = texture2D(gdepthtex,texcoord.xy).x;

	if (land > 0.9) fragpos = (gbufferModelView*(gbufferModelViewInverse*vec4(fragpos,1.0)+vec4(.0,max(cameraPosition.y-70.,.0),.0,.0))).rgb;
	vec3 uPos  = nvec3(gbufferProjectionInverse * nvec4(vec3(texcoord.xy,texture2D(depthtex1,texcoord.xy).x) * 2.0 - 1.0));		//underwater position
	float cosT = dot(normalize(fragpos),upVec);
	vec3 fogclr = getSkyColor(fragpos);
	uPos.z = mix(uPos.z,2000.0*(0.25+sunVisibility*0.75),land);

	vec3 wpos = vec3(gbufferModelViewInverse * vec4(fragpos,1.0));
//float fognoise = texture2D(noisetex,(wpos.xz+cameraPosition.xz)/8192+frametime*0.0008).r*2.0*pow(sqrt(dot(fragpos.xz, fragpos.xz)),1.0/10.0)*(1+rainStrength*2);
//vec3 fogclrnoise = getSkyColor(fragpos.xyz+vec3(0.0,(fognoise + cameraPosition.y-72.0)*(1-isEyeInWater),0.0));

	float normalDotEye = dot(normal, normalize(fragpos));
	float fresnel = pow(max(1.0 + normalDotEye,0.0), 5.);
	fresnel = mix(1.,fresnel,0.95)*0.5;


		vec3 lc = mix(vec3(0.0),sunlight*200,sunVisibility);
		vec4 reflection = vec4(0.0);
		vec3 npos = normalize(fragpos);
		vec3 reflectedVector = reflect(normalize(fragpos), normalize(normal));
		reflectedVector = fragpos + reflectedVector * (2000.0-fragpos.z);
		vec3 skyc = getSkyColor(reflectedVector);
		vec3 sky_color = drawCloud(reflectedVector,skyGradient(reflectedVector,vec3(0.0),skyc)*clamp(sky_lightmap*2.0-2/16.0,0.0,1.0));



#ifdef RAIN_REFLECTIONS
if(iswet > 0.6 && hand < 0.1 && isEyeInWater == 0){
	reflection = raytrace(fragpos, normal, sky_color, 1);
	reflection.rgb = mix(sky_color, reflection.rgb,reflection.a)+(color.a*(1-rainStrength));
	color.rgb = color.rgb +reflection.rgb/1.5*fresnel;
}
#endif
#ifdef WATER_REFLECTIONS
if (iswater > 0.9 && isEyeInWater == 0) {
	reflection = raytrace(fragpos, normal,sky_color, 0);
	reflection.rgb = mix(sky_color, reflection.rgb, reflection.a)+(color.a*2)*(lc)*(1.0-rainStrength)*(5.+SdotU*45.);
	reflection.a = min(reflection.a,1.0);
	reflection.rgb = reflection.rgb;
	color.rgb = fresnel*reflection.rgb + (1-fresnel)*color.rgb;
}
#endif
#ifdef SPECULAR
if (land < 0.9 && isEyeInWater == 0 && hand < 0.9) {
		reflection = raytrace(fragpos, normal, sky_color, specRoughness);
		reflection.rgb = mix(sky_color, reflection.rgb, reflection.a)+(color.a*(specRoughness*10))*lc*(1.0-rainStrength)*24;
		reflection.rgb = mix(reflection.rgb,reflection.rgb*normalize(color.rgb),0.0);
		reflection.rgb = (reflection.rgb*5);
		color.rgb = specRoughness*fresnel*reflection.rgb + (1-fresnel*specRoughness)*color.rgb;
		//color.rgb = specular.rgb;
	}
#endif

	/*--------------------------------*/
	if (hand < 0.1) {
		if (land < 0.9 && isEyeInWater == 0) {
		//color.rgb = calcFog(fragpos.xyz,color.rgb,(fogclrnoise));

		}
	  else {
			color.rgb = skyGradient(uPos.xyz,color.rgb,fogclr);

			if(rainStrength < 0.9)	color.rgb = drawSun(fragpos,color.rgb,land);

			if (cosT > 0. && isEyeInWater ==0) color.rgb = drawCloud(fragpos.xyz,color.rgb);
		}
	}

	if (isEyeInWater == 1) color.rgb = underwaterFog(length(fragpos),color.rgb);


	vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
	tpos = vec4(tpos.xyz/tpos.w,1.0);
	vec2 pos1 = tpos.xy/tpos.z;
	vec2 lightPos = pos1*0.5+0.5;

	#ifdef GODRAYS
	calcGodRays(lightPos);
	#endif

	float visiblesun = 0.0;
	float temp;
	float nb = 0;

	//calculate sun occlusion (only on one pixel)
	if (texcoord.x < 3.0*pw && texcoord.x < 3.0*ph) {
		for (int i = 0; i < 10;i++) {
			for (int j = 0; j < 10 ;j++) {
			temp = texture2D(gaux1,lightPos + vec2(pw*(i-5.0)*10.0,ph*(j-5.0)*10.0)).g;
			visiblesun +=  1.0-float(temp > 0.04) ;
			nb += 1;
			}
		}
		visiblesun /= nb;

	}
	#ifdef CAUSTICS_WIP
	color.rgb += waterCaustic(color.rgb, exp(-depth / 2.0), land2, worldposition) * pow(sky_lightmap,1.0) * (1 - TimeMidnight * 0.5) * (1 - rainx * 0.75) * (iswater + isEyeInWater) * (1 - iswater * isEyeInWater);
	#endif

	color.rgb = mix(getFog(color.rgb, land2, texcoord.st, getSkyColor(fragpos)), color.rgb, land*0.2);
	color += texture2D(gaux4,texcoord.xy).a*0.1;
	color.rgb = clamp(pow(color.rgb/MAX_COLOR_RANGE,vec3(1.0/2.2)),0.0,1.0);

/* DRAWBUFFERS:5 */
	gl_FragData[0] = vec4(color.rgb,visiblesun);
}
